/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.ui;//引入tools包

import android.content.Context;
import android.database.Cursor;//光标
import android.util.Log;
import android.view.View;
import android.view.ViewGroup;
import android.widget.CursorAdapter;

import net.micode.notes.data.Notes;//类名翻译：便签连接器 可能是 实现便签的编辑

import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;


public class NotesListAdapter extends CursorAdapter {//继承了CursorAdapter
    private static final String TAG = "NotesListAdapter";//设置标签字符常量
    private Context mContext;//便签数
    private HashMap<Integer, Boolean> mSelectedIndex;//HashMap是一个散列表，储存键值对的映射关系
    private int mNotesCount;//便签数
    private boolean mChoiceMode;//选择模式标志

    public static class AppWidgetAttribute {//桌面widget的属性，包括编号和类型
        public int widgetId;//函数功能：初始化便签链接器
        public int widgetType;
    };

    public NotesListAdapter(Context context) {//初始化便签链接
        super(context, null);//功能描述：NoteListAdapter的构造函数
        函数实现：继承父类函数；设置HashMap的map表，实现选择item与是否选择的键值对；设置context上下文；初始化note数量为0
        mSelectedIndex = new HashMap<Integer, Boolean>();//新建HASH表
        mContext = context;//新建一个视图来存储光标所指向的数据
        mNotesCount = 0;//初始便签数为0
    }

    @Override
    public View newView(Context context, Cursor cursor, ViewGroup parent) {//利用NotesListLtem类创建新布局
        return new NotesListItem(context);//使用noteslistitem类新建一个项目选项
    }

    @Override
    public void bindView(View view, Context context, Cursor cursor) {//将已经存在的视图和鼠标指向的数据进行捆绑
        if (view instanceof NotesListItem) {//view是NotesListItem的实例
            NoteItemData itemData = new NoteItemData(context, cursor);//新建一个项目选项并且用bind跟将view和鼠标，内容，便签数据捆绑在一起
            ((NotesListItem) view).bind(context, itemData, mChoiceMode,//用光标指向的内容新建项目并将数据、项目、鼠标、视图捆绑起来
                    isSelectedItem(cursor.getPosition()));
        }
    }

    public void setCheckedItem(final int position, final boolean checked) {//设置勾选框
        mSelectedIndex.put(position, checked);//根据定位和是否勾选设置下标
        notifyDataSetChanged();//在修改后刷新activity
    }

    public boolean isInChoiceMode() {
        return mChoiceMode;
    }//判断单选按钮是否勾选

    public void setChoiceMode(boolean mode) {//重置下标，并根据参数mode设置选项
        mSelectedIndex.clear();//清空勾选下表并根据当前mode设置
        mChoiceMode = mode;
    }

    public void selectAll(boolean checked) {//选择全部选项，遍历所有光标可用的位置在判断为便签类型之后勾选单项框
        Cursor cursor = getCursor();//获取光标位置
        for (int i = 0; i < getCount(); i++) {//遍历可用光标位置，如果光标移动且光标当前指向的便签项目类型为TYPE_NOTE则设置为勾选状态
            if (cursor.moveToPosition(i)) {//遍历所有位置并设置勾选标志
                if (NoteItemData.getNoteType(cursor) == Notes.TYPE_NOTE) {//如果是便签状态
                    setCheckedItem(i, checked);//将位置i标志为已勾选加入到 mSelectedIndex中
                }
            }
        }
    }

    public HashSet<Long> getSelectedItemIds() {//建立选择项目的ID的HASH表
        HashSet<Long> itemSet = new HashSet<Long>();//建立hash表
        for (Integer position : mSelectedIndex.keySet()) {//遍历所有的关键
            if (mSelectedIndex.get(position) == true) {//判断光标位置是否可用
                Long id = getItemId(position);
                if (id == Notes.ID_ROOT_FOLDER) {//原文件不需要添加，则将id该下标假如选项集合中
                    Log.d(TAG, "Wrong item id, should not happen");//原文件不需要添加
                } else {//如果不是，则加入条目集合
                    itemSet.add(id);//将该id加入到选项集合当中
                }
            }
        }

        return itemSet;//返回条目集合
    }

    public HashSet<AppWidgetAttribute> getSelectedWidget() {//建立桌面widget选项表
        HashSet<AppWidgetAttribute> itemSet = new HashSet<AppWidgetAttribute>();//类似于getselecteditemids的实现方法
        for (Integer position : mSelectedIndex.keySet()) {//如果光标位置可用
            if (mSelectedIndex.get(position) == true) {
                Cursor c = (Cursor) getItem(position);//用c记录光标位置以判断是否选择了桌面挂件（可用）
                if (c != null) {//获取光标位置可用
                    AppWidgetAttribute widget = new AppWidgetAttribute();//.新建widget并更新ID和类型，最后添加到选项表中
                    NoteItemData item = new NoteItemData(mContext, c);//初始化所选桌面挂件信息加入到itemSet中
                    widget.widgetId = item.getWidgetId();
                    widget.widgetType = item.getWidgetType();
                    itemSet.add(widget);//加入条目集合
                    /**
                     * Don't close cursor here, only the adapter could close it
                     */
                } else {//在这里，不关闭光标，而是在adapter中才能关闭光标
                    Log.e(TAG, "Invalid cursor");//设置标签，无效的cursor
                    return null;
                }
            }
        }
        return itemSet;
    }

    public int getSelectedCount() {//获取选项个数
        Collection<Boolean> values = mSelectedIndex.values();//获取选项下标的值
        if (null == values) {//如果此项值为空贼返回0
            return 0;
        }
        Iterator<Boolean> iter = values.iterator();//初始化迭代器
        int count = 0;
        while (iter.hasNext()) {//如果iter后面还有，则count加一
            if (true == iter.next()) {//value值为真则count加一
                count++;
            }
        }
        return count;
    }

    public boolean isAllSelected() {//判断是否全选
        int checkedCount = getSelectedCount();//通过获得计数的结果与小米便签中的数量相比较
        return (checkedCount != 0 && checkedCount == mNotesCount);//对比选项数和总数是否一致且不为0
    }

    public boolean isSelectedItem(final int position) {//判断是否为选项表
        if (null == mSelectedIndex.get(position)) {//选项下标为空则不是
            return false;
        }
        return mSelectedIndex.get(position);//判断Item是否被选中的状态
    }

    @Override
    protected void onContentChanged() {//activity内容变动时调用calcNotesCount计算便签数量
        super.onContentChanged();//执行父类函数
        calcNotesCount();
    }

    @Override
    public void changeCursor(Cursor cursor) {//activity光标变动时调用calcNotesCount计算便签数量
        super.changeCursor(cursor);//重载父类函数
        calcNotesCount();//calcNotesCount函数实现
    }

    private void calcNotesCount() {//计算便签数量
        mNotesCount = 0;
        for (int i = 0; i < getCount(); i++) {//获取总数同时遍历
            Cursor c = (Cursor) getItem(i);//遍历所有选项
            if (c != null) {//判断语句，如果光标不是null，那么便得到信息，便签数目加1
                if (NoteItemData.getNoteType(c) == Notes.TYPE_NOTE) {//如果数据是便签类型 九江计数+1
                    mNotesCount++;
                }
            } else {//设置为无效的光标
                Log.e(TAG, "Invalid cursor");//否则就将设置为无效的光标
                return;//否则就将设为无效光标
            }
        }
    }
}
